document.addEventListener("DOMContentLoaded", () => {
  document
    .getElementById("extractBtn")
    .addEventListener("click", async () => {
      const [tab] = await chrome.tabs.query({
        active: true,
        currentWindow: true,
      });

      chrome.scripting.executeScript(
        {
          target: { tabId: tab.id },
          function: extractMediaLinks,
        },
        (results) => {
          if (chrome.runtime.lastError) {
            console.error(chrome.runtime.lastError);
            return;
          }

          const mediaList = document.getElementById("mediaList");
          mediaList.innerHTML = "";
          for (const link of results[0].result) {
            const listItem = document.createElement("li");
            listItem.textContent = link;
            mediaList.appendChild(listItem);
          }
        }
      );
    });
});

function extractMediaLinks() {
  const mediaTags = ["img", "video", "audio", "source"];
  const mediaLinks = [];

  for (const tagName of mediaTags) {
    const elements = document.getElementsByTagName(tagName);
    for (const element of elements) {
      const src = element.src;
      if (src) {
        mediaLinks.push(src);
      }
    }
  }

  const fileExtensions = [".mp4", ".webm", ".ogg", ".mp3", ".wav"];
  const links = document.getElementsByTagName("a");
  for (const link of links) {
    const href = link.href;
    if (href) {
      if (fileExtensions.some((ext) => href.endsWith(ext))) {
        mediaLinks.push(href);
      } else {
        mediaLinks.push(href);
      }
    }
  }

  return mediaLinks;
}
